<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>LCOV - lcov.info - /Users/theo.germain/AndroidStudioProjects/remote_controlled_car/lib/core/data/connection/udp_connection_impl.dart</title>
  <link rel="stylesheet" type="text/css" href="../../../../../../../../gcov.css">
</head>

<body>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="title">LCOV - code coverage report</td></tr>
    <tr><td class="ruler"><img src="../../../../../../../../glass.png" width=3 height=3 alt=""></td></tr>

    <tr>
      <td width="100%">
        <table cellpadding=1 border=0 width="100%">
          <tr>
            <td width="10%" class="headerItem">Current view:</td>
            <td width="35%" class="headerValue"><a href="../../../../../../../../index.html">top level</a> - <a href="index.html">Users/theo.germain/AndroidStudioProjects/remote_controlled_car/lib/core/data/connection</a> - udp_connection_impl.dart<span style="font-size: 80%;"> (source / <a href="udp_connection_impl.dart.func-sort-c.html">functions</a>)</span></td>
            <td width="5%"></td>
            <td width="15%"></td>
            <td width="10%" class="headerCovTableHead">Hit</td>
            <td width="10%" class="headerCovTableHead">Total</td>
            <td width="15%" class="headerCovTableHead">Coverage</td>
          </tr>
          <tr>
            <td class="headerItem">Test:</td>
            <td class="headerValue">lcov.info</td>
            <td></td>
            <td class="headerItem">Lines:</td>
            <td class="headerCovTableEntry">0</td>
            <td class="headerCovTableEntry">26</td>
            <td class="headerCovTableEntryLo">0.0 %</td>
          </tr>
          <tr>
            <td class="headerItem">Date:</td>
            <td class="headerValue">2021-04-07 16:07:38</td>
            <td></td>
            <td class="headerItem">Functions:</td>
            <td class="headerCovTableEntry">0</td>
            <td class="headerCovTableEntry">0</td>
            <td class="headerCovTableEntryHi">-</td>
          </tr>
          <tr><td><img src="../../../../../../../../glass.png" width=3 height=3 alt=""></td></tr>
        </table>
      </td>
    </tr>

    <tr><td class="ruler"><img src="../../../../../../../../glass.png" width=3 height=3 alt=""></td></tr>
  </table>

  <table cellpadding=0 cellspacing=0 border=0>
    <tr>
      <td><br></td>
    </tr>
    <tr>
      <td>
<pre class="sourceHeading">          Line data    Source code</pre>
<pre class="source">
<a name="1"><span class="lineNum">       1 </span>            : import 'dart:async';</a>
<a name="2"><span class="lineNum">       2 </span>            : import 'dart:typed_data';</a>
<a name="3"><span class="lineNum">       3 </span>            : </a>
<a name="4"><span class="lineNum">       4 </span>            : import 'package:flutter/cupertino.dart';</a>
<a name="5"><span class="lineNum">       5 </span>            : import 'package:http/http.dart' as http;</a>
<a name="6"><span class="lineNum">       6 </span>            : import 'package:remote_controlled_car/core/domain/connection/web_socket_connection.dart';</a>
<a name="7"><span class="lineNum">       7 </span>            : import 'package:universal_io/io.dart';</a>
<a name="8"><span class="lineNum">       8 </span>            : import 'package:wifi/wifi.dart';</a>
<a name="9"><span class="lineNum">       9 </span>            : </a>
<a name="10"><span class="lineNum">      10 </span>            : class UdpConnectionImpl extends Connection {</a>
<a name="11"><span class="lineNum">      11 </span>            :   final StreamController&lt;Uint8List&gt; _udpStream = StreamController&lt;Uint8List&gt;();</a>
<a name="12"><span class="lineNum">      12 </span>            :   final StreamController&lt;Uint8List&gt; _udpSink = StreamController&lt;Uint8List&gt;();</a>
<a name="13"><span class="lineNum">      13 </span>            : </a>
<a name="14"><span class="lineNum">      14 </span>            :   final int listeningPort;</a>
<a name="15"><span class="lineNum">      15 </span>            :   final int writingPort;</a>
<a name="16"><span class="lineNum">      16 </span>            :   final InternetAddress ipAddr;</a>
<a name="17"><span class="lineNum">      17 </span>            : </a>
<a name="18"><span class="lineNum">      18 </span><span class="lineNoCov">          0 :   UdpConnectionImpl(</span></a>
<a name="19"><span class="lineNum">      19 </span>            :       {@required this.listeningPort,</a>
<a name="20"><span class="lineNum">      20 </span>            :       @required this.writingPort,</a>
<a name="21"><span class="lineNum">      21 </span>            :       @required this.ipAddr})</a>
<a name="22"><span class="lineNum">      22 </span><span class="lineNoCov">          0 :       : assert(listeningPort != null),</span></a>
<a name="23"><span class="lineNum">      23 </span><span class="lineNoCov">          0 :         assert(writingPort != null),</span></a>
<a name="24"><span class="lineNum">      24 </span><span class="lineNoCov">          0 :         assert(ipAddr != null) {</span></a>
<a name="25"><span class="lineNum">      25 </span><span class="lineNoCov">          0 :     sendInitReq().then((_) {</span></a>
<a name="26"><span class="lineNum">      26 </span><span class="lineNoCov">          0 :       RawDatagramSocket.bind(InternetAddress.anyIPv4, listeningPort)</span></a>
<a name="27"><span class="lineNum">      27 </span><span class="lineNoCov">          0 :           .then((RawDatagramSocket udpSocket) {</span></a>
<a name="28"><span class="lineNum">      28 </span><span class="lineNoCov">          0 :         udpSocket.forEach((RawSocketEvent event) {</span></a>
<a name="29"><span class="lineNum">      29 </span><span class="lineNoCov">          0 :           if (event == RawSocketEvent.read) {</span></a>
<a name="30"><span class="lineNum">      30 </span><span class="lineNoCov">          0 :             Datagram dg = udpSocket.receive();</span></a>
<a name="31"><span class="lineNum">      31 </span>            :             //print('size: ' + dg.data.length.toString());</a>
<a name="32"><span class="lineNum">      32 </span><span class="lineNoCov">          0 :             _udpStream.sink.add(dg.data);</span></a>
<a name="33"><span class="lineNum">      33 </span>            :           }</a>
<a name="34"><span class="lineNum">      34 </span>            :         });</a>
<a name="35"><span class="lineNum">      35 </span><span class="lineNoCov">          0 :         _udpSink.stream.listen(</span></a>
<a name="36"><span class="lineNum">      36 </span><span class="lineNoCov">          0 :             (Uint8List data) =&gt; udpSocket.send(data, ipAddr, writingPort));</span></a>
<a name="37"><span class="lineNum">      37 </span>            :       });</a>
<a name="38"><span class="lineNum">      38 </span>            :     });</a>
<a name="39"><span class="lineNum">      39 </span>            :   }</a>
<a name="40"><span class="lineNum">      40 </span>            : </a>
<a name="41"><span class="lineNum">      41 </span><span class="lineNoCov">          0 :   Stream&lt;Uint8List&gt; get stream =&gt; _udpStream.stream;</span></a>
<a name="42"><span class="lineNum">      42 </span>            : </a>
<a name="43"><span class="lineNum">      43 </span><span class="lineNoCov">          0 :   Sink&lt;Uint8List&gt; get sink =&gt; _udpSink.sink;</span></a>
<a name="44"><span class="lineNum">      44 </span>            : </a>
<a name="45"><span class="lineNum">      45 </span><span class="lineNoCov">          0 :   Future&lt;void&gt; sendInitReq() async {</span></a>
<a name="46"><span class="lineNum">      46 </span>            :     http.Response res;</a>
<a name="47"><span class="lineNum">      47 </span><span class="lineNoCov">          0 :     String localIp = await Wifi.ip;</span></a>
<a name="48"><span class="lineNum">      48 </span>            : </a>
<a name="49"><span class="lineNum">      49 </span><span class="lineNoCov">          0 :     while (res == null || res.statusCode != 200) {</span></a>
<a name="50"><span class="lineNum">      50 </span>            :       try {</a>
<a name="51"><span class="lineNum">      51 </span><span class="lineNoCov">          0 :         res = await http.get(Uri.parse(</span></a>
<a name="52"><span class="lineNum">      52 </span><span class="lineNoCov">          0 :             'http://${ipAddr.address}/start?ip=$localIp&amp;port=$listeningPort'));</span></a>
<a name="53"><span class="lineNum">      53 </span><span class="lineNoCov">          0 :         print(res?.statusCode);</span></a>
<a name="54"><span class="lineNum">      54 </span>            :       } catch (e) {</a>
<a name="55"><span class="lineNum">      55 </span><span class="lineNoCov">          0 :         print(e);</span></a>
<a name="56"><span class="lineNum">      56 </span>            :         res = null;</a>
<a name="57"><span class="lineNum">      57 </span>            :       }</a>
<a name="58"><span class="lineNum">      58 </span><span class="lineNoCov">          0 :       await Future.delayed(Duration(seconds: 3));</span></a>
<a name="59"><span class="lineNum">      59 </span>            :     }</a>
<a name="60"><span class="lineNum">      60 </span>            :   }</a>
<a name="61"><span class="lineNum">      61 </span>            : </a>
<a name="62"><span class="lineNum">      62 </span><span class="lineNoCov">          0 :   void dispose() {</span></a>
<a name="63"><span class="lineNum">      63 </span><span class="lineNoCov">          0 :     _udpStream.close();</span></a>
<a name="64"><span class="lineNum">      64 </span><span class="lineNoCov">          0 :     _udpSink.close();</span></a>
<a name="65"><span class="lineNum">      65 </span>            :   }</a>
<a name="66"><span class="lineNum">      66 </span>            : }</a>
</pre>
      </td>
    </tr>
  </table>
  <br>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="ruler"><img src="../../../../../../../../glass.png" width=3 height=3 alt=""></td></tr>
    <tr><td class="versionInfo">Generated by: <a href="http://ltp.sourceforge.net/coverage/lcov.php" target="_parent">LCOV version 1.15</a></td></tr>
  </table>
  <br>

</body>
</html>
